xref: /linux/scripts/link-vmlinux.sh (revision 7d153696e5db1e37387c2f7ec06ffc8d4aac70a4)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37is_enabled() {
38	grep -q "^$1=y" include/config/auto.conf
39}
40
41# Nice output in kbuild format
42# Will be supressed by "make -s"
43info()
44{
45	printf "  %-7s %s\n" "${1}" "${2}"
46}
47
48# Generate a linker script to ensure correct ordering of initcalls.
49gen_initcalls()
50{
51	info GEN .tmp_initcalls.lds
52
53	${PYTHON} ${srctree}/scripts/jobserver-exec		\
54	${PERL} ${srctree}/scripts/generate_initcall_order.pl	\
55		${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}	\
56		> .tmp_initcalls.lds
57}
58
59# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
60# .tmp_symversions.lds
61gen_symversions()
62{
63	info GEN .tmp_symversions.lds
64	rm -f .tmp_symversions.lds
65
66	for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
67		if [ -f ${o}.symversions ]; then
68			cat ${o}.symversions >> .tmp_symversions.lds
69		fi
70	done
71}
72
73# Link of vmlinux.o used for section mismatch analysis
74# ${1} output file
75modpost_link()
76{
77	local objects
78	local lds=""
79
80	objects="--whole-archive				\
81		${KBUILD_VMLINUX_OBJS}				\
82		--no-whole-archive				\
83		--start-group					\
84		${KBUILD_VMLINUX_LIBS}				\
85		--end-group"
86
87	if is_enabled CONFIG_LTO_CLANG; then
88		gen_initcalls
89		lds="-T .tmp_initcalls.lds"
90
91		if is_enabled CONFIG_MODVERSIONS; then
92			gen_symversions
93			lds="${lds} -T .tmp_symversions.lds"
94		fi
95
96		# This might take a while, so indicate that we're doing
97		# an LTO link
98		info LTO ${1}
99	else
100		info LD ${1}
101	fi
102
103	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
104}
105
106objtool_link()
107{
108	local objtoolcmd;
109	local objtoolopt;
110
111	if is_enabled CONFIG_LTO_CLANG && is_enabled CONFIG_STACK_VALIDATION; then
112		# Don't perform vmlinux validation unless explicitly requested,
113		# but run objtool on vmlinux.o now that we have an object file.
114		if is_enabled CONFIG_UNWINDER_ORC; then
115			objtoolcmd="orc generate"
116		fi
117
118		objtoolopt="${objtoolopt} --duplicate"
119
120		if is_enabled CONFIG_FTRACE_MCOUNT_USE_OBJTOOL; then
121			objtoolopt="${objtoolopt} --mcount"
122		fi
123	fi
124
125	if is_enabled CONFIG_VMLINUX_VALIDATION; then
126		objtoolopt="${objtoolopt} --noinstr"
127	fi
128
129	if [ -n "${objtoolopt}" ]; then
130		if [ -z "${objtoolcmd}" ]; then
131			objtoolcmd="check"
132		fi
133		objtoolopt="${objtoolopt} --vmlinux"
134		if ! is_enabled CONFIG_FRAME_POINTER; then
135			objtoolopt="${objtoolopt} --no-fp"
136		fi
137		if is_enabled CONFIG_GCOV_KERNEL || is_enabled CONFIG_LTO_CLANG; then
138			objtoolopt="${objtoolopt} --no-unreachable"
139		fi
140		if is_enabled CONFIG_RETPOLINE; then
141			objtoolopt="${objtoolopt} --retpoline"
142		fi
143		if is_enabled CONFIG_X86_SMAP; then
144			objtoolopt="${objtoolopt} --uaccess"
145		fi
146		info OBJTOOL ${1}
147		tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
148	fi
149}
150
151# Link of vmlinux
152# ${1} - output file
153# ${2}, ${3}, ... - optional extra .o files
154vmlinux_link()
155{
156	local output=${1}
157	local objs
158	local libs
159	local ld
160	local ldflags
161	local ldlibs
162
163	info LD ${output}
164
165	# skip output file argument
166	shift
167
168	if is_enabled CONFIG_LTO_CLANG; then
169		# Use vmlinux.o instead of performing the slow LTO link again.
170		objs=vmlinux.o
171		libs=
172	else
173		objs="${KBUILD_VMLINUX_OBJS}"
174		libs="${KBUILD_VMLINUX_LIBS}"
175	fi
176
177	if [ "${SRCARCH}" = "um" ]; then
178		wl=-Wl,
179		ld="${CC}"
180		ldflags="${CFLAGS_vmlinux}"
181		ldlibs="-lutil -lrt -lpthread"
182	else
183		wl=
184		ld="${LD}"
185		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
186		ldlibs=
187	fi
188
189	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
190
191	# The kallsyms linking does not need debug symbols included.
192	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
193		ldflags="${ldflags} ${wl}--strip-debug"
194	fi
195
196	if is_enabled CONFIG_VMLINUX_MAP; then
197		ldflags="${ldflags} ${wl}-Map=${output}.map"
198	fi
199
200	${ld} ${ldflags} -o ${output}					\
201		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
202		${wl}--start-group ${libs} ${wl}--end-group		\
203		$@ ${ldlibs}
204}
205
206# generate .BTF typeinfo from DWARF debuginfo
207# ${1} - vmlinux image
208# ${2} - file to dump raw BTF data into
209gen_btf()
210{
211	local pahole_ver
212
213	if ! [ -x "$(command -v ${PAHOLE})" ]; then
214		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
215		return 1
216	fi
217
218	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
219	if [ "${pahole_ver}" -lt "116" ]; then
220		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
221		return 1
222	fi
223
224	vmlinux_link ${1}
225
226	info "BTF" ${2}
227	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
228
229	# Create ${2} which contains just .BTF section but no symbols. Add
230	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
231	# deletes all symbols including __start_BTF and __stop_BTF, which will
232	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
233	# objcopy warnings: "empty loadable segment detected at ..."
234	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
235		--strip-all ${1} ${2} 2>/dev/null
236	# Change e_type to ET_REL so that it can be used to link final vmlinux.
237	# Unlike GNU ld, lld does not allow an ET_EXEC input.
238	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
239}
240
241# Create ${2} .S file with all symbols from the ${1} object file
242kallsyms()
243{
244	local kallsymopt;
245
246	if is_enabled CONFIG_KALLSYMS_ALL; then
247		kallsymopt="${kallsymopt} --all-symbols"
248	fi
249
250	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
251		kallsymopt="${kallsymopt} --absolute-percpu"
252	fi
253
254	if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
255		kallsymopt="${kallsymopt} --base-relative"
256	fi
257
258	info KSYMS ${2}
259	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
260}
261
262# Perform one step in kallsyms generation, including temporary linking of
263# vmlinux.
264kallsyms_step()
265{
266	kallsymso_prev=${kallsymso}
267	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
268	kallsymso=${kallsyms_vmlinux}.o
269	kallsyms_S=${kallsyms_vmlinux}.S
270
271	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
272	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
273
274	info AS ${kallsyms_S}
275	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
276	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
277	      -c -o ${kallsymso} ${kallsyms_S}
278}
279
280# Create map file with all symbols from ${1}
281# See mksymap for additional details
282mksysmap()
283{
284	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
285}
286
287sorttable()
288{
289	${objtree}/scripts/sorttable ${1}
290}
291
292# Delete output files in case of error
293cleanup()
294{
295	rm -f .btf.*
296	rm -f .tmp_System.map
297	rm -f .tmp_initcalls.lds
298	rm -f .tmp_symversions.lds
299	rm -f .tmp_vmlinux*
300	rm -f System.map
301	rm -f vmlinux
302	rm -f vmlinux.map
303	rm -f vmlinux.o
304	rm -f .vmlinux.d
305}
306
307# Use "make V=1" to debug this script
308case "${KBUILD_VERBOSE}" in
309*1*)
310	set -x
311	;;
312esac
313
314if [ "$1" = "clean" ]; then
315	cleanup
316	exit 0
317fi
318
319# Update version
320info GEN .version
321if [ -r .version ]; then
322	VERSION=$(expr 0$(cat .version) + 1)
323	echo $VERSION > .version
324else
325	rm -f .version
326	echo 1 > .version
327fi;
328
329# final build of init/
330${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
331
332#link vmlinux.o
333modpost_link vmlinux.o
334objtool_link vmlinux.o
335
336# modpost vmlinux.o to check for section mismatches
337${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
338
339info MODINFO modules.builtin.modinfo
340${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
341info GEN modules.builtin
342# The second line aids cases where multiple modules share the same object.
343tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
344	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
345
346btf_vmlinux_bin_o=""
347if is_enabled CONFIG_DEBUG_INFO_BTF; then
348	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
349	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
350		echo >&2 "Failed to generate BTF for vmlinux"
351		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
352		exit 1
353	fi
354fi
355
356kallsymso=""
357kallsymso_prev=""
358kallsyms_vmlinux=""
359if is_enabled CONFIG_KALLSYMS; then
360
361	# kallsyms support
362	# Generate section listing all symbols and add it into vmlinux
363	# It's a three step process:
364	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
365	#     but __kallsyms is empty.
366	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
367	#     the right size
368	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
369	#     the right size, but due to the added section, some
370	#     addresses have shifted.
371	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
372	# 3)  That link may have expanded the kernel image enough that
373	#     more linker branch stubs / trampolines had to be added, which
374	#     introduces new names, which further expands kallsyms. Do another
375	#     pass if that is the case. In theory it's possible this results
376	#     in even more stubs, but unlikely.
377	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
378	#     other bugs.
379	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
380	#
381	# a)  Verify that the System.map from vmlinux matches the map from
382	#     ${kallsymso}.
383
384	kallsyms_step 1
385	kallsyms_step 2
386
387	# step 3
388	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
389	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
390
391	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
392		kallsyms_step 3
393	fi
394fi
395
396vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
397
398# fill in BTF IDs
399if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
400	info BTFIDS vmlinux
401	${RESOLVE_BTFIDS} vmlinux
402fi
403
404if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
405	info SORTTAB vmlinux
406	if ! sorttable vmlinux; then
407		echo >&2 Failed to sort kernel tables
408		exit 1
409	fi
410fi
411
412info SYSMAP System.map
413mksysmap vmlinux System.map
414
415# step a (see comment above)
416if is_enabled CONFIG_KALLSYMS; then
417	mksysmap ${kallsyms_vmlinux} .tmp_System.map
418
419	if ! cmp -s System.map .tmp_System.map; then
420		echo >&2 Inconsistent kallsyms data
421		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
422		exit 1
423	fi
424fi
425
426# For fixdep
427echo "vmlinux: $0" > .vmlinux.d
428